<?php
/**
 * $Id: carbon_console.inc,v 1.1 2006/12/01 21:43:25 johnackers Exp $ 
 * 
 * Drupal carbon module 
 *
 * Created on 30-Nov-2006
 *
 * @file
 * This file provides optional test and diagnostic tools for the 
 * carbon module.  
 */
 


function carbon_console($a = NULL, $b = NULL, $c = NULL)  
{
  $output = null ;    
  
  $post = $_POST ;  

  if (isset($_POST['op']))
  {
  	$op = $_POST['op']; 

    $output .= "op is ".$op."<br/>" ;
    
    if ($op == 'check tables') 
        $output .=  _check_all_tables();
    if ($op == 'create data') 
    {
        $output .=  _create_data($_POST['edit']['name']);
    }  
    return $output ;   
  }


  $form = array();


  $form['data'] = array('#type' => 'fieldset',
    '#title' => t('Test Accounts'),
//    '#prefix' => '<div class="container-inline">',
 //   '#suffix' => '</div>',
    '#weight' => '-6',
  );  

  $form["data"]["name"] = array(
      "#type" => "textfield", 
    "#title" => t("Name"), 
    "#required" => TRUE, 
    "#default_value" => ' ',
    "#weight" => -1,
    "#description" => "Name of the test account.");


  $form['data']['op1'] = array('#type' => 'submit', '#value' => t('create data'));


  $form['tables'] = array('#type' => 'fieldset',
    '#title' => t('Tables'),
//    '#prefix' => '<div class="container-inline">',
 //   '#suffix' => '</div>',
    '#weight' => '-6',
  );
 
  $form['tables']['op2'] = array('#type' => 'submit', '#value' => t('check tables'));

  $output .= drupal_get_form('carbon_console', $form);
  return $output ; 
}



function _check_all_tables()
{
    $tables = _check_tables_present(array("carbon_source", "carbon_footprint", "carbon_stamp", "carbon_stamp_footprint"));

    $out = '' ; 
    $num = 0 ; 
    foreach($tables as $tablename => $rowcount)
    {
        if (empty($rowcount))
            $rowcount  = '<b>not present</b>' ;
        else
            $num++ ; 
        $out .= '<p>Table has '.$tablename. ', row count '.$rowcount .'</p>';
    }
    return $out ;
}

/**
 * This may only work with mysql
 * 
 * @param an array of table names
 * @return an array of key pairs that contain the name and row count.
 */


function _check_tables_present($tablename)
{
    $sql = "show tables"; 
    $table = $table2 = array(); 
    $db_query = db_query($sql); 
    while  ($result = db_fetch_object($db_query))
    {
        $table[$result->Tables_in_carbon] = "0" ;
    }   
    $num = 0 ; 
    foreach ($tablename as $name)
    {   
        if (array_key_exists($name, $table))
        {
            $db_query2 = db_query('select count(*) as count from '.$name); 
            $result2 = db_fetch_object($db_query2);
            $table2[$name] = $result2->count ;
        }       
        else
            $table2[$name] = '' ;       
    }       
    return $table2 ;    
}  


function _create_data($name)
{
	$fid = 1881 ; 
    
  $output = 'account created for '. $name ;  
  _create_stamps($fid);
	return $output ; 
}


function _create_stamps($fid){
  global $user ;
  
  $data = array(
    array("home",              "elec-kwh",        0, 500, 0.5),

    array("home meter",        "gas-kwh",         1, 100.11, 0.5),
    array("home meter",        "gas-kwh",         1, 200.22, 0.5),
    array("home meter",        "gas-kwh",         1, 300.33, 0.5),
            
    array("daily commute",     "car-small-miles", 2,  10, 0.5),
    array("train",             "pt-miles",        0,1000,  1),
    array("10 short flights",  "air-miles",       0, 100,  10),
    array("1  long flight",    "air-miles",       0, 100,  10),
  );  

    
  for ($i = 0 ;  $i < 8  ; $i++) 
  {       
  	
    $y = 2000 ; 
    $startdate = mktime(0, 0, 0, 6, 1, $y );
    $enddate = mktime(0, 0, 0, 6, 1, $y + 1 );
    create_stamp($data, $fid, $i, $startdate, $enddate);
  } 
}      
      
      
function create_stamp($data, $fid, $i, $startdate, $enddate) 
{
      $j = 0 ;
      $stamp = new Node(); 
      $stamp->title =      $data[$i][$j++] ; 
      $stamp->code =       $data[$i][$j++] ;  
      $stamp->scope =      $data[$i][$j++] ;  
      $stamp->reading =    $data[$i][$j++] ;  
      $stamp->adjustment = $data[$i][$j++] ;
           
      $stamp->startdate = $startdate ;                      
      $stamp->enddate = $enddate;    
      
      $stamp->protection = 0 ; 
      $stamp->exclude = false ;                   
    
      $stamp->fid = $fid; 
      $stamp->uid = $user->uid ;  
      $stamp->type = 'carbon_stamp' ;             
      $stamp->status = 1 ;
      node_save($stamp);   
}


?>
